<?php
namespace Codappix\SearchCore\Connection;

/*
 * Copyright (C) 2016  Daniel Siepmann <coding@daniel-siepmann.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

use TYPO3\CMS\Extbase\Persistence\QueryResultInterface;

/**
 * A search result.
 */
interface SearchResultInterface extends \Iterator, \Countable, QueryResultInterface
{
    /**
     * @return array<ResultItemInterface>
     */
    public function getResults() : array;

    /**
     * Return all facets, if any.
     *
     * @return array<FacetInterface>
     */
    public function getFacets() : array;

    /**
     * Returns the number of results in current result
     */
    public function getCurrentCount() : int;
}
